{ SOI 2015 Creativity Task 'Bazaar'.

  Sample bot in Pascal.
  contact: sebastian@soi.ch }

program bot(output);

{ Game configuration. }
var n, a, d, g, auction :  integer;
var players, bids :  array of integer;

   procedure init();
      { Initialize the bot. }
   begin
      Randomize();
      read(n); read(a); read(d); read(g);
      SetLength(players, n);
      SetLength(bids, d);
   end;

   procedure playAuction();
      { Play a single auction. }
      var i, round, bid :  integer;
   begin
      { Distribute the available gold randomly. }
      for i := 1 to d do bids[i-1] := 0;
      for i := 1 to g do inc(bids[Random(d)]);

      { Initialize the players. }
      for i := 1 to n do players[i-1] := 0;

      { Play the auction. }
      for round := 1 to d do
      begin
	 { Place the bid. }
	 writeln(bids[round-1]);
	 flush(output);

	 { Keep track of every player's gold. }
	 dec(players[0], bids[round-1]);
	 for i := 1 to n-1 do
         begin
	    read(bid);
	    dec(players[i], bid);
	 end; 
      end;
   end;

begin
   { Initialize bot. }
   init();

   { Participate in the auctions. }
   for auction := 1 to a do
      playAuction();
end.
