//  SOI 2015 Creativity Task 'Bazaar'
//
//  Sample bot in Java
//  contact:sebastian@soi

import java.util.*;
import java.lang.*;
import java.io.*;

class bot {
  //  Game configuration. 
  final int n, a, d, g;

  //  IO.
  final Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));

  //  Source of randomness.
  final Random shaker = new Random(0);

  bot() {
    //  Initialize the bot.
    n = in.nextInt(); a = in.nextInt(); d = in.nextInt(); g = in.nextInt();
  }

  void playAuction() {
    //  Play a single auction. 
    final int[] players = new int[n];
    final int[] bids = new int[d];

    //  Distribute the available gold randomly.
    for (int coin=0; coin<g; coin++) ++bids[shaker.nextInt(d)]; 
    
    //  Initialize the players: every player starts with the equal amount of money.
    for (int i=0; i<n; i++) players[i] = g;
  
    //  Play the auction.
    for (int round=0; round<d; round++) {
      //  Place the bid.
      System.out.println(bids[round]);
      System.out.flush();

      //  Keep track of every player's gold.
      players[0] -= bids[round];
      for (int i=1; i<n; i++) players[i] -= in.nextInt();
    }
  }

  void play() {
    for (int auction=0; auction<a; auction++)
      playAuction();
  }

  public static void main(String[] args) throws IOException {
    bot player = new bot();
    player.play();    
  }  
}
